apiVersion: apps.openshift.io/v1
kind: DeploymentConfig
metadata:
  name: {{ include "bbbAtScale.fullname" . }}
  labels:
    {{- include "bbbAtScale.labels" . | nindent 4 }}
spec:
{{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCountRqWorker }}
{{- end }}
  selector:
    {{- include "bbbAtScale.selectorLabels" . | nindent 6 }}
  template:
    metadata:
    {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      labels:
        {{- include "bbbAtScale.selectorLabels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "bbbAtScale.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      volumes:
        - name: config
          configMap:
            name: {{ include "bbbAtScale.fullname" . }}-files
            defaultMode: 420
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http
              containerPort: 8000
              protocol: TCP
          envFrom:
            - configMapRef:
                name: {{ include "bbbAtScale.fullname" . }}
          env:
            - name: SECURE_PROXY_SSL_HEADER
              value: HTTP_X_FORWARDED_PROTO
            - name: POSTGRES_DB
              value: {{ .Values.postgresql.postgresqlDatabase }}
            - name: POSTGRES_USER
              value: {{ .Values.postgresql.postgresqlUsername }}
            - name: POSTGRES_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Release.Name }}-postgresql
                  key: postgresql-password
            - name: POSTGRES_HOST
              value: {{ .Release.Name }}-postgresql
            - name: DJANGO_SECRET_KEY
              valueFrom:
                secretKeyRef:
                  name: {{ include "bbbAtScale.fullname" . }}
                  key: DJANGO_SECRET_KEY
            - name: RECORDINGS_SECRET
              valueFrom:
                secretKeyRef:
                  name: {{ include "bbbAtScale.fullname" . }}
                  key: RECORDINGS_SECRET
            - name: LDAP_BINDDN
              valueFrom:
                secretKeyRef:
                  name: {{ include "bbbAtScale.fullname" . }}
                  key: LDAP_BINDDN
            - name: LDAP_BINDPASS
              valueFrom:
                secretKeyRef:
                  name: {{ include "bbbAtScale.fullname" . }}
                  key: LDAP_BINDPASS
            - name: REDIS_HOST
              value: {{ .Release.Name }}-redis-master
            - name: REDIS_PORT
              value: {{ .Values.redis.redisPort | quote }}
            - name: REDIS_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Release.Name }}-redis
                  key: redis-password
            {{- if .Values.bbbAtScaleShibbolethSP.enabled }}
            - name: SHIBBOLETH
              value: enabled
            - name: SHIBBOLETH_OVER_HTTP_HEADER
              value: "true"
            {{- end }}
          volumeMounts:
            {{- if .Values.bbbAtScale.configmapfiles.create -}}
            {{- toYaml .Values.bbbAtScale.volumeMounts | nindent 12 }}
            {{- end }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
  triggers:
  - type: {{ .Values.triggers.type }}
  - imageChangeParams:
      automatic: true
      containerNames:
        - {{ .Chart.Name }}
      from:
        kind: ImageStreamTag
        name: {{ include "bbbAtScale.fullname" . }}:{{ .Values.triggers.imageTag }}
    type: ImageChange
  strategy:
    type: {{ .Values.triggers.strategyType }}